#include "NoBlock.h"

NoBlock::NoBlock()
    : Block( NoBlockBlockType::INSTANCE, 0, { 0,0,0 }, false )
{
    transparent = 0;
    passable = 0;
    hp = 0;
    maxHP = 0;
    hardness = 0;
}

bool NoBlock::onTick( TickQueue* zQueue, int numTicks, bool& blocked )
{
    return 0;
}

void NoBlock::onPostTick() {}

const NoBlock NoBlock::INSTANCE;


NoBlockBlockType::NoBlockBlockType()
    : BlockType( ID, 0 )
{}

NoBlockBlockType::NoBlockBlockType( int id )
    : BlockType( id, 0 )
{}

Block* NoBlockBlockType::createBlock( Framework::Vec3<int> position ) const
{
    return 0;
}

Item* NoBlockBlockType::createItem() const
{
    return 0;
}

Block* NoBlockBlockType::loadBlock( Framework::Vec3<int> position, Framework::StreamReader* zReader ) const
{
    return 0;
}

void NoBlockBlockType::saveBlock( Block* zBlock, Framework::StreamWriter* zWriter ) const
{}

Item* NoBlockBlockType::getItemFromBlock( Block* zBlock ) const
{
    return 0;
}

Block* NoBlockBlockType::createBlockAt( Framework::Vec3<int> position, Item* zUsedItem ) const
{
    return 0;
}

const Block* NoBlockBlockType::zDefault() const
{
    return &NoBlock::INSTANCE;
}

AirBlock::AirBlock()
    : Block( AirBlockBlockType::INSTANCE, 0, { 0,0,0 }, false )
{
    transparent = 1;
    passable = 1;
    hp = 0;
    maxHP = 0;
    hardness = 0;
}

bool AirBlock::onTick( TickQueue* zQueue, int numTicks, bool& blocked )
{
    return 0;
}

void AirBlock::onPostTick()
{}

const AirBlock AirBlock::INSTANCE;


AirBlockBlockType::AirBlockBlockType()
    : NoBlockBlockType( ID )
{}

const Block* AirBlockBlockType::zDefault() const
{
    return &AirBlock::INSTANCE;
}